import java.sql.*;

/**
 *  Creates a backup of the user table.  Backup table is user_backup.
 *
 * @author     Brandon Douthit-Wood
 * @created    March 31, 2004
 */
public class BackupUserTable {

	/**
	 *  Creates a backup of the user table.
	 *
	 * @param  args  The command line arguments
	 */
	public static void main( String[] args ) {
		String query = "";

		if ( !Query.connectToDB() ) {
			System.exit( 0 );
		}

		// clear old backup table
		System.out.println( "Clearing old backup..." );
		query = "delete from user_backup";
		Query.executeUpdate( query );

		// create new backup
		System.out.println( "Creating new backup..." );
		query = "insert into user_backup (id,cluster_id,pos_words,pos_word_freq,neg_words,neg_word_freq)";
		query += " select id,cluster_id,pos_words,pos_word_freq,neg_words,neg_word_freq from user";
		Query.executeUpdate( query );
	}
}

